<script setup>
defineProps({
  object: {
    type: Object,
    required: true,
  },
  active: {
    type: Boolean,
    default: false,
  },
  selected: {
    type: Boolean,
    default: false,
  },
});

const emit = defineEmits(["choose", "open", "select"]);

function handleChoose() {
  emit("choose");
}

function emitSelection(value) {
  emit("select", value);
}
</script>

<template>
  <div
    class="d-flex mt-0 pointer-cursor hover py-1"
    :class="{ active: active }"
    @click="handleChoose"
    @dblclick="$emit('open')"
  >
    <div v-if="object.has_children">
      <v-btn
        density="compact"
        icon="mdi-chevron-right"
        color="grey"
        variant="plain"
        @click.stop="
          () => {
            $emit('open');
          }
        "
      />
    </div>
    <div v-else>
      <v-checkbox-btn
        :model-value="selected"
        density="compact"
        color="grey"
        @update:modelValue="emitSelection"
      />
    </div>
    <i
      :class="`mx-1 my-auto ${object.icon}`"
      @click.stop="
        () => {
          $emit('open');
        }
      "
    />
    <v-icon
      v-if="!object.icon"
      class="mx-1 my-auto"
      size="15"
      icon="fa: fas fa-circle-question"
      @click.stop="
        () => {
          $emit('open');
        }
      "
    />
    <v-img
      v-if="object.icon.toLowerCase().includes('.png', '.jpg', '.jpeg', '.svg')"
      max-width="15"
      :src="object.icon"
      @click.stop="
        () => {
          $emit('open');
        }
      "
    />
    <div class="me-auto my-auto text-truncate" :class="[{ 'font-weight-bold': active }]">
      &nbsp;{{ object.name }}
    </div>
  </div>
</template>

<style>
.hover:hover {
  background-color: #f2f2f2;
}

.active {
  background-color: #f2f2f2;
}
</style>
